'----------------------
' Using Database and ODBC with Fnx Basic
' Bruno Quenec'hdu - France
' File odbcAPI.inc V1.0
'----------------------

uses OdbcAPI

'----------------------
' Dclaration des variables globales
'----------------------
dim glEnv as long
dim glDBC as long
dim glSQLstmt as long
'----------------------


object main_form as form
  caption="Using ODBC with FNXBASIC : Select * from table1"
  width=700
  height=400
  object button1 as button
    top=10
    left=10
    width=100
    height=30
    caption="Run ODBC"
    onclick=prog_main
  end object
  object edit1 as richedit
    top=50
    left=10
    width=200
    height=300
  end object
  object grid1 as stringgrid
    top=50
    left= 250
    width= 400
    height=300
    while grid1.rowcount>1
      delrow(2)
    wend
    while grid1.colcount>1
      delcol(1)
    wend
  end object
  ShowModal
end object



sub prog_main(b as button)
dim SQL as string
dim nbcol as integer 
dim nblig as integer
dim colval as string
dim lgcolval as long
dim datatype as  short
dim dataprecision as integer
dim datascale as short
dim datanullable as short

dim sqlstate as string
dim nativeerror as integer 

dim i as short
dim Wstr as string

  edit1.text =""
  'ODBC tape 1 : dclaration de l'environnement ODBC
  SQLAllocEnv.env = varptr(glEnv)
  SQLAllocEnv.execute

  add_text(edit1,"-Allocation de l'environnement ODBC", SQLALLOCEnv.result).


  'ODBC tape 2 : Dclaration de l'environnement de DataBase
  SQLAllocConnect.env=glEnv
  SQLAllocConnect.dbc=varptr(glDbc)
  SQLAllocConnect.execute
  
  add_text(edit1,"-Allocation de l'environnement Database", SQLAllocConnect.result)
 

  'ODBC tape 3 : connexion  la Database par le DNS NAme dclarer par l'ODBCmanager, ici test
  SQLConnect.dbc=glDbc
  SQLConnect.DNS="test"
  SQLConnect.DNSlen=4
  SQLConnect.uid=""
  SQLConnect.uidlen=0
  SQLConnect.pwd =""
  SQLConnect.pwdlen =0
  SQLConnect.execute
  add_text(edit1,"-Connexion  la source de donnes ODBC", SQLConnect.result)

  'ODBC tape 4 : dclaration d' environnement de l'ordre SQL
   SQLAllocStmt.dbc=glDbc
   SQLAllocStmt.SQLStmt=varptr(glSQLstmt)
   SQLAllocStmt.execute
   add_text(edit1,"-Allocation de l ordre SQL", SQLAllocStmt.result)

  'ODBC tape 5 : envoie de la requte Sql (Ici un Select )  la database 
   SQL ="select * from table1"
   SQLExecDirect.SQLStmt =glSQLStmt
   SQLExecDirect.sqlString =SQL
   SQLExecDirect.sqlstrlen =len(SQL)
   SQLExecDirect.execute 

   ' no syntax error  
   if SQLExecDirect.result = 0 then
  'traitement des rsultats
  ' suppression des colonnes et lignes du Grid
      while grid1.rowcount>1
        grid1.delrow(2)
      wend
      while grid1.colcount>1
        grid1.delcol(1)
      wend
   
     SQLNumResultCols.SQLStmt =glSQLstmt
     SQLNumResultCols.NumCols =varptr(nbcol)
     SQLNumResultCols.execute
     add_text(edit1,"-Rcupration du nombre de colonnes", SQLNumResultCols.result)
    
     ' Mise  jour du nombre de colonne du Grid
     grid1.colWidth(0)=grid1.width/nbcol
     for i=2 to nbcol
       grid1.insertcol(i)
	 grid1.colWidth(i-1)=grid1.width/nbcol
     next i
     ' rcupration des noms des colonnes pour ligne 1 du grid.
     for i=1 to nbcol
         SQLDescribeCol.SQLStmt=glSQLstmt
         SQLDescribeCol.colnum =i
         SQLDescribeCol.Buflen =255
         SQLDescribeCol.colnamelen =varptr(lgcolval)
         SQLDescribeCol.datatype = varptr(datatype)
         SQLDescribeCol.precision = varptr(dataprecision)
         SQLDescribeCol.scale = varptr(datascale)
         SQLDescribeCol.nullable = varptr(datanullable)
	   SQLDescribeCol.execute

      wstr = SQLDescribeCol.colname +" "
           
     

     Select case datatype
     case SQL_CHAR
      wstr= wstr + "CHAR"
     case SQL_NUMERIC
      wstr= wstr + "NUMERIC" 
     case SQL_DECIMAL
    wstr= wstr + "DECIMAL"
     case SQL_INTEGER
    wstr= wstr + "INTEGER"  
     case SQL_SMALLINT
    wstr= wstr + "SMALLINT"
     case SQL_FLOAT
    wstr= wstr + "FLOAT"
     case SQL_REAL
    wstr= wstr + "REAL"
     case SQL_DOUBLE
    wstr= wstr + "DOUBLE"
     case SQL_DATETIME
    wstr= wstr + "Date/time"
     case SQL_VARCHAR
    wstr= wstr + "VARCHAR"
     End Select

	
     if datanullable= SQL_NULLABLE then
        wstr=wstr+" Nullable"
     else
        wstr=wstr+" Not Null"
     end if 
     
     grid1.cell(i-1,0)=wstr    
  next i

     ' first row of the grid witch receive data
     nblig=1
     ' first row of data
 
     SQLFetch.SQLStmt=glSQLstmt
     SQLFetch.execute
     
     while SQLFetch.result <> SQL_NO_DATA_FOUND
    
        Grid1.insertrow(nblig)
        for i=1 to nbcol
        SQLGetData.SQLStmt=glSQLstmt
        SQLGetData.colnum = i
	  SQLGetdata.lpbBuf=colval
        ' Convertion des rsultats en Char pour affichage dans la cellule du grid
        SQLGetData.ConvType= 1
        SQLGetData.buflen =255
        SQLGetData.execute

        grid1.cell(i-1,nblig)=SQLGetdata.lpbBuf

       next i
       nblig=nblig+1
       SQLFetch.SQLStmt=glSQLstmt
       SQLFetch.execute
     wend
   else
 
      SQLError.env = glEnv 
      SQLError.dbc = glDbc
      SQLError.SQLStmt = glSQLstmt
      
      'SQLError.NativeError = varptr(nativeError)
      
      SQLError.Buflen = 255
      SQLError.Outlen = varptr(lgcolval)
      SQLerror.execute

      wstr= "Erreur SQL "+ CR
      wstr= wstr + "ODBC State : "+ SQLError.SQLstate + CR
	wstr= wstr + "ODBC Native Error : "+ str$(SQLError.NativeError) + CR
      Wstr= wstr + "ODBC Message : " + SQLError.buffer
  
      i=MessageDlg(wstr,"Erreur SQL", mbok+mbiconhand)
   
   end if

  'ODBC tape 6 : liberation des environnements SQL, puis Database ,et ODBC
   add_text(edit1,"-Dsallocation environnement SQL,DATABASE et ODBC", 0)	
   SQLFreeStmt.SQLStmt=glSQLstmt
   SQLFreeStmt.EndOption =SQL_DROP
   SQLFreeStmt.execute
   
  SQLFreeConnect.dbc=glDbc
  SQLFreeConnect.execute

  SQLFreeEnv.env =glEnv
  SQLFreeEnv.execute
 
end sub

sub add_text(e as richedit, t as string, r as short)
dim x as integer
dim title as string
  title=str$(r)
  e.text=e.text +t +"- "
  if r=0 then
    e.text=e.text+ "OK"+ CR
  else
    e.text=e.text+ "KO"+ CR
    x=Messagedlg(t,title,mbok+mbiconexclamation)
  end if  
end SUB

