'-----------------------------------------
' Fichier de dclaration des constantes et des fonctions ODBC
'-----------------------------------------
' Bruno Qunec'hdu - France
' Version 1.0 Aout 2012
'-----------------------------------------


' Dclaration des constantes
' Longueur du buffer de retour des valeurs
Const MAX_DATA_BUFFER = 255
' Code de russites ou d'erreurs d'excutions 
Const SQL_SUCCESS = 0
Const SQL_SUCCESS_WITH_INFO = 1  
Const SQL_ERROR = -1
' code de fin de rsultat pour la fonction SQL Fetch
Const SQL_NO_DATA_FOUND = 100  
'  type de  liberation 
Const SQL_CLOSE = 0
Const SQL_DROP = 1
' Code du type de la colonne pour la paramtre dtype de la fonction SQlDescribe Col
Const SQL_CHAR = 1
Const SQL_NUMERIC = 2  
Const SQL_DECIMAL = 3
Const SQL_INTEGER = 4  
Const SQL_SMALLINT = 5
Const SQL_FLOAT = 6  
Const SQL_REAL = 7
Const SQL_DOUBLE = 8 
Const SQL_DATETIME = 11
Const SQL_VARCHAR = 12
' pour teste la propriete Null
Const SQL_NO_NULLS = 0
Const SQL_NULLABLE = 1


' 
Const SQL_DRIVER_NOPROMPT = 0
Const SQL_DRIVER_COMPLETE = 1
Const SQL_DRIVER_PROMPT  = 2
Const SQL_DRIVER_COMPLETE_REQUIRED  = 3
Const SQL_DATA_SOURCE_NAME = 6  
Const SQL_USER_NAME = 8
' Env : For Odbc Environlment
' dbc : For DataBase Context
' SQLstmt : For SQL statement

'Test OK
Declare  SQLAllocEnv as "SQLAllocEnv" of "odbc32.dll"
  env As long 
  result as short
end declare

'Test OK
Declare SQLFreeEnv as "SQLFreeEnv" of "odbc32.dll" 
  env As long 
  result as short
end declare

'Test OK
Declare SQLAllocConnect as "SQLAllocConnect" of "odbc32.dll"
  env As long  
  dbc As long 
  result as short
end declare

'Test OK
Declare SQLConnect as "SQLConnect" of "odbc32.dll"
  dbc As long
  DNS As String
  DNSlen As short
  uid As String
  uidlen  As short
  pwd As String
  pwdlen As short
  result as short
end declare

' Pas  tester
Declare SQLDriverConnect as "SQLDriverConnect" of "odbc32.dll"
      dbc As long
      hWnd As long
      connect As String 
      connectlen As short
      resultat As long
      resultatlen As short
      isize As long
      flagdriver As short
      result as short
end declare

'Test OK
Declare SQLFreeConnect as "SQLFreeConnect" of "odbc32.dll"
      dbc As long
      result as short
end declare

'Test OK
Declare SQLDisconnect as "SQLDisconnect" of "odbc32.dll"
      dbc  As long
      result as short
end declare

'Test OK
Declare SQLAllocStmt as "SQLAllocStmt" of "odbc32.dll"
      dbc As long
      SQLStmt As long
      result as short
end declare

'test OK
Declare SQLFreeStmt as "SQLFreeStmt" of "odbc32.dll"
      SQLStmt As long
      EndOption As Integer
      result as short
end declare

'Pas tester
Declare SQLTables as "SQLTables" of "odbc32.dll"
      SQLStmt As long
      q As long
      cbq As Integer
      o As long
      cbo As Integer
      t As long
      cbt As Integer
      tt As long 
      cbtt As Integer
      result as short
end declare

'test ok
Declare SQLExecDirect as "SQLExecDirect" of "odbc32.dll"
      SQLStmt As long
      sqlString As String
      sqlstrlen As Long
      result as short
end declare

'test ok
Declare SQLNumResultCols as "SQLNumResultCols" of "odbc32.dll"
      SQLStmt As long
      NumCols As long
	result as short
end declare

'test KO
Declare SQLDescribeCol as "SQLDescribeCol" of "odbc32.dll"
      SQLStmt As long
      colnum As short 
      colname As string byaddress
      Buflen As short
      colnamelen As long
      datatype As long
      precision As long
      scale As long
      nullable As long
      result as short
end declare

'test ok
Declare SQLFetch as "SQLFetch" of "odbc32.dll"
      SQLStmt As  long
      result as short
end declare

'test ok
Declare SQLGetData as "SQLGetData" of "odbc32.dll"
      SQLStmt As long
      colnum As short
      ConvType As long
      lpbBuf As string byaddress
      buflen As long
      lpcbout As long byaddress
      result as short
end declare

'pas tester
Declare SQLGetInfo as "SQLGetInfo" of "odbc32.dll"
      dbc As long
      hWnd As long
      szInfo As String
      cbInfoMax As Integer
      cbInfoOut As Integer
      result as short
end declare

'Test ok
Declare SQLError as "SQLError" of "odbc32.dll" 
      env As long 
      dbc As long
      SQLStmt As long
      SQLState As string byaddress
      NativeError As integer byaddress
      Buffer As string byaddress
      Buflen As Integer
      Outlen As long
      result as short
end declare